script_name('TimeOnScreen')
script_author('Meow Brightside')
local res                   = pcall(require, 'lib.moonloader')                      assert(res, 'Lib MOONLOADER not found!')
local res                   = pcall(require, 'lib.sampfuncs')                       assert(res, 'Lib SAMPFUNCS not found')
local res, inicfg           = pcall(require, 'inicfg')                              assert(res, 'Lib INICFG not found')
local res, socket           = pcall(require, 'socket')                              assert(res, 'Lib SOCKET not found')
local moving = false
local f_ini         = getGameDirectory().."\\moonloader\\BrightsideProjects\\TimeOnScreen\\settings.ini"
ini = {
    settings = {
        activate = true,
        x = 130,
        y = 727,
        color = "FFFFFF",
        msColor = "858585",
        fontsize = 12
    }
}
local config = inicfg.load(nil, f_ini)
function main()
    if not isSampLoaded() or not isSampfuncsLoaded() then error(script_name..' needs SA:MP and SAMPFUNCS!') end
    while not isSampAvailable() do wait(100) end
    ----------------------------------------------------------------
    if config == nil then
        createDirectory(getGameDirectory().."\\moonloader\\BrightsideProjects\\TimeOnScreen")
        local f = io.open(f_ini, "w")
        f:close()
        if inicfg.save(ini, f_ini) then 
            config = inicfg.load(nil, f_ini)
        end
        print("Created default settings.ini") 
    end
    font = renderCreateFont("Arial", config.settings.fontsize, 5)
    sampRegisterChatCommand('ctime', cmd_stime)
    local hour = tonumber(os.date("%H"))
    local name = sampGetPlayerNickname(select(2, sampGetPlayerIdByCharHandle(PLAYER_PED)))
    while true do
        wait(0)
        if config.settings.activate or moving then
            if moving then
                sampToggleCursor(true)
                local x, y = getCursorPos()
                config.settings.x = x
                config.settings.y = y
                if isKeyJustPressed(0x01) then
                    moving = false
                    sampToggleCursor(false)
                    inicfg.save(config, f_ini)
                end
            end
            local date_table = os.date("*t")
            local ms = tostring(math.ceil(socket.gettime()*1000))
            local ms = tonumber(string.sub(ms, #ms-2, #ms))
            local hour, minute, second = date_table.hour, date_table.min, date_table.sec
            local result = string.format("%02d:%02d:%02d{" ..config.settings.msColor.. "}.%03d", hour, minute, second, ms)

            renderFontDrawText(font, result, config.settings.x, config.settings.y, "0xFF"..config.settings.color)
        end
    end
end
function chatmsg(text)
    sampAddChatMessage(string.format("{FFC93E}[cTime]: {FFFFFF}%s", text), 0xA77BCA)
end
function cmd_stime()
    lua_thread.create(function()
        local dtext = "   \t" .. (config.settings.activate and "{45d900}ON\n" or "{ff0000}OFF\n") 
        local dtext = dtext .. " :\t" .. config.settings.fontsize .. "\n"                   
        local dtext = dtext .. " :\t{" .. config.settings.color .. "}||||||||||\n"           
        local dtext = dtext .. " :\t{" .. config.settings.msColor .. "}||||||||||\n"     
        local dtext = dtext .. " \t x:" .. config.settings.x .. " y:" .. config.settings.y .. "\n"                                                     
        sampShowDialog(10, "{FFC93E}cTime", dtext, "OK", "", DIALOG_STYLE_TABLIST)
        while sampIsDialogActive(10) do wait(0) end
        local result, button, list, input = sampHasDialogRespond(10)

        if result and button == 1 then
            if list == 0 then
                config.settings.activate = not config.settings.activate
                inicfg.save(config, f_ini)
                return true
            end

            if list == 1 then
                sampShowDialog(11, "{FFC93E}cTime", "{FFFFFF}  :", "OK", "", DIALOG_STYLE_INPUT)
                while sampIsDialogActive(11) do wait(0) end
                local result, button, list, input = sampHasDialogRespond(11)
                if result then
                    if tonumber(input) then
                        config.settings.fontsize = tonumber(input)
                        font = renderCreateFont('Arial', config.settings.fontsize, 5)
                        inicfg.save(config, f_ini)
                        return true
                    else
                        chatmsg("   !")
                        return true
                    end
                else
                    return true
                end
            end

            if list == 2 then
                sampShowDialog(11, "{FFC93E}cTime", "{FFFFFF} HEX  :\n{c3c3c3}: {AE433D}\nAE433D\n{A77BCA}A77BCA {c3c3c3}\n(  {FFFFFF}FFFFFF{c3c3c3})", "OK", "", DIALOG_STYLE_INPUT)
                while sampIsDialogActive(11) do wait(0) end
                local result, button, list, input = sampHasDialogRespond(11)
                if result then
                    if not input:match("[--ߨ]+") then
                        config.settings.color = input
                        inicfg.save(config, f_ini)
                        return true
                    else
                        chatmsg(" .")
                        return true
                    end
                else
                    return true
                end
            end

            if list == 3 then
                sampShowDialog(11, "{FFC93E}cTime", "{FFFFFF} HEX  :\n{c3c3c3}: {AE433D}\nAE433D\n{A77BCA}A77BCA {c3c3c3}\n(  {858585}858585{c3c3c3})", "OK", "", DIALOG_STYLE_INPUT)
                while sampIsDialogActive(11) do wait(0) end
                local result, button, list, input = sampHasDialogRespond(11)
                if result then
                    if not input:match("[--ߨ]+") then
                        config.settings.msColor = input
                        inicfg.save(config, f_ini)
                        return true
                    else
                        chatmsg(" .")
                        return true
                    end
                else
                    return true
                end
            end

            if list == 4 then
                moving = true
                chatmsg("    .")
            end
        end
    end)
end
